// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * UTC time with the epoch of midnight (00:00:00) of 1970-01-01. The presentation is defined in the
 * SCSMs.The NULL time stamp has all fields set to 0 (zero).The relation between a timestamp value, the
 * synchronization of an internal time with an external time source (for example, UTC time), and other
 * information related to time model are available as requirements in Clause 21.
 * </pre>
 *
 * Protobuf type {@code commonmodule.Timestamp}
 */
public final class Timestamp extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.Timestamp)
    TimestampOrBuilder {
private static final long serialVersionUID = 0L;
  // Use Timestamp.newBuilder() to construct.
  private Timestamp(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private Timestamp() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new Timestamp();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Timestamp_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Timestamp_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.Timestamp.class, openfmb.commonmodule.Timestamp.Builder.class);
  }

  public static final int SECONDS_FIELD_NUMBER = 2;
  private long seconds_ = 0L;
  /**
   * <pre>
   * Second since epoch (1970-01-01T00:00:00Z)
   * </pre>
   *
   * <code>uint64 seconds = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The seconds.
   */
  @java.lang.Override
  public long getSeconds() {
    return seconds_;
  }

  public static final int TQ_FIELD_NUMBER = 3;
  private openfmb.commonmodule.TimeQuality tq_;
  /**
   * <pre>
   * IEC61850 time quality
   * </pre>
   *
   * <code>.commonmodule.TimeQuality tq = 3;</code>
   * @return Whether the tq field is set.
   */
  @java.lang.Override
  public boolean hasTq() {
    return tq_ != null;
  }
  /**
   * <pre>
   * IEC61850 time quality
   * </pre>
   *
   * <code>.commonmodule.TimeQuality tq = 3;</code>
   * @return The tq.
   */
  @java.lang.Override
  public openfmb.commonmodule.TimeQuality getTq() {
    return tq_ == null ? openfmb.commonmodule.TimeQuality.getDefaultInstance() : tq_;
  }
  /**
   * <pre>
   * IEC61850 time quality
   * </pre>
   *
   * <code>.commonmodule.TimeQuality tq = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.TimeQualityOrBuilder getTqOrBuilder() {
    return tq_ == null ? openfmb.commonmodule.TimeQuality.getDefaultInstance() : tq_;
  }

  public static final int NANOSECONDS_FIELD_NUMBER = 4;
  private int nanoseconds_ = 0;
  /**
   * <pre>
   * Partial (sub) second expressed in nanoseconds (10&lt;sup&gt;-9&lt;/sup&gt; second).
   * </pre>
   *
   * <code>uint32 nanoseconds = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The nanoseconds.
   */
  @java.lang.Override
  public int getNanoseconds() {
    return nanoseconds_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (seconds_ != 0L) {
      output.writeUInt64(2, seconds_);
    }
    if (tq_ != null) {
      output.writeMessage(3, getTq());
    }
    if (nanoseconds_ != 0) {
      output.writeUInt32(4, nanoseconds_);
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (seconds_ != 0L) {
      size += com.google.protobuf.CodedOutputStream
        .computeUInt64Size(2, seconds_);
    }
    if (tq_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getTq());
    }
    if (nanoseconds_ != 0) {
      size += com.google.protobuf.CodedOutputStream
        .computeUInt32Size(4, nanoseconds_);
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.Timestamp)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.Timestamp other = (openfmb.commonmodule.Timestamp) obj;

    if (getSeconds()
        != other.getSeconds()) return false;
    if (hasTq() != other.hasTq()) return false;
    if (hasTq()) {
      if (!getTq()
          .equals(other.getTq())) return false;
    }
    if (getNanoseconds()
        != other.getNanoseconds()) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + SECONDS_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
        getSeconds());
    if (hasTq()) {
      hash = (37 * hash) + TQ_FIELD_NUMBER;
      hash = (53 * hash) + getTq().hashCode();
    }
    hash = (37 * hash) + NANOSECONDS_FIELD_NUMBER;
    hash = (53 * hash) + getNanoseconds();
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.Timestamp parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.Timestamp parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.Timestamp parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.Timestamp parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.Timestamp parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.Timestamp parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.Timestamp parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.Timestamp parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.Timestamp parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.Timestamp parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.Timestamp parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.Timestamp parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.Timestamp prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * UTC time with the epoch of midnight (00:00:00) of 1970-01-01. The presentation is defined in the
   * SCSMs.The NULL time stamp has all fields set to 0 (zero).The relation between a timestamp value, the
   * synchronization of an internal time with an external time source (for example, UTC time), and other
   * information related to time model are available as requirements in Clause 21.
   * </pre>
   *
   * Protobuf type {@code commonmodule.Timestamp}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.Timestamp)
      openfmb.commonmodule.TimestampOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Timestamp_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Timestamp_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.Timestamp.class, openfmb.commonmodule.Timestamp.Builder.class);
    }

    // Construct using openfmb.commonmodule.Timestamp.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      seconds_ = 0L;
      tq_ = null;
      if (tqBuilder_ != null) {
        tqBuilder_.dispose();
        tqBuilder_ = null;
      }
      nanoseconds_ = 0;
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_Timestamp_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.Timestamp getDefaultInstanceForType() {
      return openfmb.commonmodule.Timestamp.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.Timestamp build() {
      openfmb.commonmodule.Timestamp result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.Timestamp buildPartial() {
      openfmb.commonmodule.Timestamp result = new openfmb.commonmodule.Timestamp(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.Timestamp result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.seconds_ = seconds_;
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.tq_ = tqBuilder_ == null
            ? tq_
            : tqBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.nanoseconds_ = nanoseconds_;
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.Timestamp) {
        return mergeFrom((openfmb.commonmodule.Timestamp)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.Timestamp other) {
      if (other == openfmb.commonmodule.Timestamp.getDefaultInstance()) return this;
      if (other.getSeconds() != 0L) {
        setSeconds(other.getSeconds());
      }
      if (other.hasTq()) {
        mergeTq(other.getTq());
      }
      if (other.getNanoseconds() != 0) {
        setNanoseconds(other.getNanoseconds());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 16: {
              seconds_ = input.readUInt64();
              bitField0_ |= 0x00000001;
              break;
            } // case 16
            case 26: {
              input.readMessage(
                  getTqFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 26
            case 32: {
              nanoseconds_ = input.readUInt32();
              bitField0_ |= 0x00000004;
              break;
            } // case 32
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private long seconds_ ;
    /**
     * <pre>
     * Second since epoch (1970-01-01T00:00:00Z)
     * </pre>
     *
     * <code>uint64 seconds = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The seconds.
     */
    @java.lang.Override
    public long getSeconds() {
      return seconds_;
    }
    /**
     * <pre>
     * Second since epoch (1970-01-01T00:00:00Z)
     * </pre>
     *
     * <code>uint64 seconds = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The seconds to set.
     * @return This builder for chaining.
     */
    public Builder setSeconds(long value) {

      seconds_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Second since epoch (1970-01-01T00:00:00Z)
     * </pre>
     *
     * <code>uint64 seconds = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearSeconds() {
      bitField0_ = (bitField0_ & ~0x00000001);
      seconds_ = 0L;
      onChanged();
      return this;
    }

    private openfmb.commonmodule.TimeQuality tq_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.TimeQuality, openfmb.commonmodule.TimeQuality.Builder, openfmb.commonmodule.TimeQualityOrBuilder> tqBuilder_;
    /**
     * <pre>
     * IEC61850 time quality
     * </pre>
     *
     * <code>.commonmodule.TimeQuality tq = 3;</code>
     * @return Whether the tq field is set.
     */
    public boolean hasTq() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * IEC61850 time quality
     * </pre>
     *
     * <code>.commonmodule.TimeQuality tq = 3;</code>
     * @return The tq.
     */
    public openfmb.commonmodule.TimeQuality getTq() {
      if (tqBuilder_ == null) {
        return tq_ == null ? openfmb.commonmodule.TimeQuality.getDefaultInstance() : tq_;
      } else {
        return tqBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * IEC61850 time quality
     * </pre>
     *
     * <code>.commonmodule.TimeQuality tq = 3;</code>
     */
    public Builder setTq(openfmb.commonmodule.TimeQuality value) {
      if (tqBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        tq_ = value;
      } else {
        tqBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 time quality
     * </pre>
     *
     * <code>.commonmodule.TimeQuality tq = 3;</code>
     */
    public Builder setTq(
        openfmb.commonmodule.TimeQuality.Builder builderForValue) {
      if (tqBuilder_ == null) {
        tq_ = builderForValue.build();
      } else {
        tqBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 time quality
     * </pre>
     *
     * <code>.commonmodule.TimeQuality tq = 3;</code>
     */
    public Builder mergeTq(openfmb.commonmodule.TimeQuality value) {
      if (tqBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          tq_ != null &&
          tq_ != openfmb.commonmodule.TimeQuality.getDefaultInstance()) {
          getTqBuilder().mergeFrom(value);
        } else {
          tq_ = value;
        }
      } else {
        tqBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 time quality
     * </pre>
     *
     * <code>.commonmodule.TimeQuality tq = 3;</code>
     */
    public Builder clearTq() {
      bitField0_ = (bitField0_ & ~0x00000002);
      tq_ = null;
      if (tqBuilder_ != null) {
        tqBuilder_.dispose();
        tqBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * IEC61850 time quality
     * </pre>
     *
     * <code>.commonmodule.TimeQuality tq = 3;</code>
     */
    public openfmb.commonmodule.TimeQuality.Builder getTqBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getTqFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * IEC61850 time quality
     * </pre>
     *
     * <code>.commonmodule.TimeQuality tq = 3;</code>
     */
    public openfmb.commonmodule.TimeQualityOrBuilder getTqOrBuilder() {
      if (tqBuilder_ != null) {
        return tqBuilder_.getMessageOrBuilder();
      } else {
        return tq_ == null ?
            openfmb.commonmodule.TimeQuality.getDefaultInstance() : tq_;
      }
    }
    /**
     * <pre>
     * IEC61850 time quality
     * </pre>
     *
     * <code>.commonmodule.TimeQuality tq = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.TimeQuality, openfmb.commonmodule.TimeQuality.Builder, openfmb.commonmodule.TimeQualityOrBuilder> 
        getTqFieldBuilder() {
      if (tqBuilder_ == null) {
        tqBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.TimeQuality, openfmb.commonmodule.TimeQuality.Builder, openfmb.commonmodule.TimeQualityOrBuilder>(
                getTq(),
                getParentForChildren(),
                isClean());
        tq_ = null;
      }
      return tqBuilder_;
    }

    private int nanoseconds_ ;
    /**
     * <pre>
     * Partial (sub) second expressed in nanoseconds (10&lt;sup&gt;-9&lt;/sup&gt; second).
     * </pre>
     *
     * <code>uint32 nanoseconds = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The nanoseconds.
     */
    @java.lang.Override
    public int getNanoseconds() {
      return nanoseconds_;
    }
    /**
     * <pre>
     * Partial (sub) second expressed in nanoseconds (10&lt;sup&gt;-9&lt;/sup&gt; second).
     * </pre>
     *
     * <code>uint32 nanoseconds = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The nanoseconds to set.
     * @return This builder for chaining.
     */
    public Builder setNanoseconds(int value) {

      nanoseconds_ = value;
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Partial (sub) second expressed in nanoseconds (10&lt;sup&gt;-9&lt;/sup&gt; second).
     * </pre>
     *
     * <code>uint32 nanoseconds = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearNanoseconds() {
      bitField0_ = (bitField0_ & ~0x00000004);
      nanoseconds_ = 0;
      onChanged();
      return this;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.Timestamp)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.Timestamp)
  private static final openfmb.commonmodule.Timestamp DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.Timestamp();
  }

  public static openfmb.commonmodule.Timestamp getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<Timestamp>
      PARSER = new com.google.protobuf.AbstractParser<Timestamp>() {
    @java.lang.Override
    public Timestamp parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<Timestamp> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<Timestamp> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.Timestamp getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

